Public Class Form1
	Public g_CtiLogin As TMClientAccess.CtiLogin
	Public g_Telephony As TMClientAccess.Telephony
	Public g_Messages As TMClientAccess.Messages
	Public g_CtiConvert As TMClientAccess.CtiConvert

	Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		'Initialize the interface
		g_CtiLogin = New TMClientAccess.CtiLogin
		g_Telephony = New TMClientAccess.Telephony
		g_Messages = New TMClientAccess.Messages
		g_CtiConvert = New TMClientAccess.CtiConvert

		'Add event handler
		AddHandler g_Telephony.OnForwardingState, AddressOf OnForwardingState
		AddHandler g_Telephony.OnCallNumber, AddressOf OnCallNumber
		AddHandler g_Telephony.OnProtocolData, AddressOf OnProtocolData
		AddHandler g_Telephony.OnGroupMember, AddressOf OnGroupMember
		AddHandler g_Telephony.OnSendUserState, AddressOf OnSendUserState

		'prepare start
		g_CtiLogin.AssistedTelephony = True
		g_CtiLogin.AutoConnect = True
		g_CtiLogin.AutoLogin = True
		g_CtiLogin.CheckConnection = True
		g_CtiLogin.PhoneIcon = True
		g_CtiLogin.ShowIcon = True
		g_CtiLogin.OwnNumber = "100"
		g_CtiLogin.Port = 2501
		g_CtiLogin.ServerName = "localhost"

		g_CtiLogin.StartClient()
	End Sub

	Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

		'Remove event handler
		RemoveHandler g_Telephony.OnForwardingState, AddressOf OnForwardingState
		RemoveHandler g_Telephony.OnCallNumber, AddressOf OnCallNumber
		RemoveHandler g_Telephony.OnProtocolData, AddressOf OnProtocolData
		RemoveHandler g_Telephony.OnGroupMember, AddressOf OnGroupMember
		RemoveHandler g_Telephony.OnSendUserState, AddressOf OnSendUserState
	End Sub

	Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
		'Change the interface network settings
		g_CtiLogin.NetworkConfigDialog()
	End Sub

	Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
		'Make a call
		g_Telephony.MakeCall(TextBox1.Text)
	End Sub

	Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
		'Drop the call
		g_Telephony.Hangup(0)
	End Sub

	Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
		'Answer an incoming call
		g_Telephony.Answer(0)
	End Sub

	Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
		'Set forward
		g_Telephony.SetForwarding(CheckBox1.Checked, TextBox2.Text)
	End Sub

	Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
		'Pickup a call
		g_Telephony.Pickup(TextBox3.Text)
	End Sub

	Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
		'Close the program
		Close()
	End Sub

	Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
		'Hold the first call
		g_Telephony.Hold(0)
	End Sub

	Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
		'Unhold = Retrieve
		g_Telephony.UnHold(0)
	End Sub

	Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
		'Transfer
		g_Telephony.Transfer(0, 0)
	End Sub

	Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
		'Redirect existing call
		g_Telephony.Redirect(0, TextBox5.Text)
	End Sub
	Private Sub Member1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member1.Click
		'Dial a Number
		g_Telephony.MakeCall(Member1.Tag.ToString())
	End Sub

	Private Sub Member2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member2.Click
		'Dial a Number
		g_Telephony.MakeCall(Member2.Tag.ToString())
	End Sub

	Private Sub Member3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member3.Click
		'Dial a Number
		g_Telephony.MakeCall(Member3.Tag.ToString())
	End Sub

	Private Sub Member4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member4.Click
		'Dial a Number
		g_Telephony.MakeCall(Member4.Tag.ToString())
	End Sub

	Private Sub Member5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member5.Click
		'Dial a Number
		g_Telephony.MakeCall(Member5.Tag.ToString())
	End Sub

	Private Sub Member6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member6.Click
		'Dial a Number
		g_Telephony.MakeCall(Member6.Tag.ToString())
	End Sub

	Private Sub Member7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member7.Click
		'Dial a Number
		g_Telephony.MakeCall(Member7.Tag.ToString())
	End Sub

	Private Sub Member8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member8.Click
		'Dial a Number
		g_Telephony.MakeCall(Member8.Tag.ToString())
	End Sub

	Private Sub Member9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member9.Click
		'Dial a Number
		g_Telephony.MakeCall(Member9.Tag.ToString())
	End Sub

	Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
		'Clear call list
		ListBox1.Items.Clear()
	End Sub

	Private Sub OnForwardingState(ByVal sender As Object, ByVal e As TMClientAccessArgs.ForwardingStateArgs)
		'Get the Forwarding state
		TextBox2.Text = e.strNumber
		CheckBox1.Checked = e.bSet
	End Sub

	Private Sub OnCallNumber(ByVal sender As Object, ByVal e As TMClientAccessArgs.CallNumberArgs)
		'Number of caller will be delivered
		Label4.Text = e.strNumber
		If Label4.Text = "" Then
			Label4.Text = "Unknown"
		End If
	End Sub

	Private Sub OnProtocolData(ByVal sender As Object, ByVal e As TMClientAccessArgs.ProtocolDataArgs)
		Dim TextLine As String
		Dim DatumText As String
		Dim InboundText As String
		Dim Duration As Long
		DatumText = ""
		InboundText = "Outbound"
		If e.bInbound = True Then
			InboundText = "Inbound"
		End If
		Duration = e.dwEndTime - e.dwStartTime
		DatumText = g_CtiConvert.GetFormatDateTime(e.dwStartTime, "%Y-%B-%d %H:%M:%S")
		TextLine = DatumText + " Own:" + e.strOwn + " Other:" + e.strOther + " Duration:" + Duration.ToString() + " " + InboundText
		ListBox1.Items.Add(TextLine)
	End Sub

	Private Sub OnGroupMember(ByVal sender As Object, ByVal e As TMClientAccessArgs.GroupMemberArgs)
		'Delivers the group members. Use it for the group buttons.
		If Member1.Text = "" Then
			If e.strName <> "" Then
				Member1.Text = e.strName
			Else
				Member1.Text = e.strNumber
			End If
			Member1.Enabled = True
			Member1.Tag = e.strNumber
		ElseIf Member2.Text = "" Then
			If e.strName <> "" Then
				Member2.Text = e.strName
			Else
				Member2.Text = e.strNumber
			End If
			Member2.Enabled = True
			Member2.Tag = e.strNumber
		ElseIf Member3.Text = "" Then
			If e.strName <> "" Then
				Member3.Text = e.strName
			Else
				Member3.Text = e.strNumber
			End If
			Member3.Enabled = True
			Member3.Tag = e.strNumber
		ElseIf Member4.Text = "" Then
			If e.strName <> "" Then
				Member4.Text = e.strName
			Else
				Member4.Text = e.strNumber
			End If
			Member4.Enabled = True
			Member4.Tag = e.strNumber
		ElseIf Member5.Text = "" Then
			If e.strName <> "" Then
				Member5.Text = e.strName
			Else
				Member5.Text = e.strNumber
			End If
			Member5.Enabled = True
			Member5.Tag = e.strNumber
		ElseIf Member6.Text = "" Then
			If e.strName <> "" Then
				Member6.Text = e.strName
			Else
				Member6.Text = e.strNumber
			End If
			Member6.Enabled = True
			Member6.Tag = e.strNumber
		ElseIf Member7.Text = "" Then
			If e.strName <> "" Then
				Member7.Text = e.strName
			Else
				Member7.Text = e.strNumber
			End If
			Member7.Enabled = True
			Member7.Tag = e.strNumber
		ElseIf Member8.Text = "" Then
			If e.strName <> "" Then
				Member8.Text = e.strName
			Else
				Member8.Text = e.strNumber
			End If
			Member8.Enabled = True
			Member8.Tag = e.strNumber
		ElseIf Member9.Text = "" Then
			If e.strName <> "" Then
				Member9.Text = e.strName
			Else
				Member9.Text = e.strNumber
			End If
			Member9.Enabled = True
			Member9.Tag = e.strNumber
		End If
	End Sub

	Private Sub OnSendUserState(ByVal sender As Object, ByVal e As TMClientAccessArgs.SendUserStateArgs)
		'Send the state of the group member
		If e.strNumber = Member1.Tag Then
			If e.bRinging = True Then
				Member1.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member1.BackColor = Color.Red
			Else
				Member1.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member1.ForeColor = Color.DarkOrange
			Else
				Member1.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member2.Tag Then
			If e.bRinging = True Then
				Member2.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member2.BackColor = Color.Red
			Else
				Member2.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member2.ForeColor = Color.DarkOrange
			Else
				Member2.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member3.Tag Then
			If e.bRinging = True Then
				Member3.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member3.BackColor = Color.Red
			Else
				Member3.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member3.ForeColor = Color.DarkOrange
			Else
				Member3.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member4.Tag Then
			If e.bRinging = True Then
				Member4.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member4.BackColor = Color.Red
			Else
				Member4.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member4.ForeColor = Color.DarkOrange
			Else
				Member4.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member5.Tag Then
			If e.bRinging = True Then
				Member5.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member5.BackColor = Color.Red
			Else
				Member5.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member5.ForeColor = Color.DarkOrange
			Else
				Member5.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member6.Tag Then
			If e.bRinging = True Then
				Member6.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member6.BackColor = Color.Red
			Else
				Member6.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member6.ForeColor = Color.DarkOrange
			Else
				Member6.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member7.Tag Then
			If e.bRinging = True Then
				Member7.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member7.BackColor = Color.Red
			Else
				Member7.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member7.ForeColor = Color.DarkOrange
			Else
				Member7.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member8.Tag Then
			If e.bRinging = True Then
				Member8.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member8.BackColor = Color.Red
			Else
				Member8.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member8.ForeColor = Color.DarkOrange
			Else
				Member8.ForeColor = Color.Black
			End If
		ElseIf e.strNumber = Member9.Tag Then
			If e.bRinging = True Then
				Member9.BackColor = Color.Magenta
			ElseIf e.bActiveCall = True Then
				Member9.BackColor = Color.Red
			Else
				Member9.BackColor = Nothing
			End If
			If e.bLogin = True Then
				Member9.ForeColor = Color.DarkOrange
			Else
				Member9.ForeColor = Color.Black
			End If
		End If
	End Sub
End Class
