//****************************************************************************************
#include "stdafx.h"
//****************************************************************************************
// CInsertNameDlg dialog
IMPLEMENT_DYNAMIC(CInsertNameDlg, CDialog)
//****************************************************************************************
// constructor
CInsertNameDlg::CInsertNameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInsertNameDlg::IDD, pParent)
	, m_szName(_T(""))
	, m_szNumber(_T(""))
{
}
//****************************************************************************************
// Read dialog data
void CInsertNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NAME, m_Name);
	DDX_Control(pDX, IDC_NUMBER, m_Number);
	DDX_Control(pDX, IDOK, m_BnOk);
	DDX_Text(pDX, IDC_NAME, m_szName);
	DDX_Text(pDX, IDC_NUMBER, m_szNumber);
}
//****************************************************************************************
// Evaluate messages
BOOL CInsertNameDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(LOWORD(wParam))
	{
	case IDC_NAME:
	case IDC_NUMBER:
		{
			if(HIWORD(wParam) == EN_CHANGE)
			{
				UpdateData();
				BOOL bActive = TRUE;
				if(m_szName.IsEmpty()){bActive = FALSE;}
				if(m_szNumber.IsEmpty()){bActive = FALSE;}
				m_BnOk.EnableWindow(bActive);
			}// if(HIWORD(wParam) == EN_CHANGE)
			break;
		}
	}// switch(LOWORD(wParam))

	return CWnd::OnCommand(wParam,lParam);
}
//****************************************************************************************
BEGIN_MESSAGE_MAP(CInsertNameDlg, CDialog)
END_MESSAGE_MAP()
//****************************************************************************************
