//****************************************************************************************
#pragma once
//****************************************************************************************
// CMiniCTIInCDlg
class CMiniCTIInCDlg : public CDialog
{
public:
	CMiniCTIInCDlg(CWnd* pParent = NULL);
	virtual ~CMiniCTIInCDlg();
	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedNetwork();
	afx_msg void OnBnClickedAnswer();
	afx_msg void OnBnClickedDrop();
	afx_msg void OnBnClickedBook();
	afx_msg void OnBnClickedList();
	afx_msg void OnMove(int x, int y);

	enum { IDD = IDD_MINICTIINC_DIALOG };
protected:
	static CMiniCTIInCDlg* m_pThis;
	HICON m_hIcon;
	BOOL m_bIsConnected;
	BOOL m_bInitReady;
	BOOL m_bActiveCall;
	BOOL m_bRingingCall;
	BOOL m_bIsActive;
	HICON m_hIconOn;
	HICON m_hIconOff;
	HMENU m_hMainMenu;
	HMENU m_hPopupMenu;
	CButton m_Network;
	CButton m_Answer;
	CButton m_Drop;
	CButton m_Book;
	CButton m_List;
	virtual void DoDataExchange(CDataExchange* pDX);
	VOID ActivateItems();
	VOID TranslateServerMessage(LP_CTI_COMMAND_MSG);
	static VOID WINAPI CTICallbackFunc(DWORD,WPARAM,LPARAM);

	virtual BOOL OnInitDialog();
};
//****************************************************************************************
