﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CanonicalDotNet
{
    public partial class Form1 : Form
	{
        public TMCanConvert.CanConverter g_Converter;
        public Form1()
		{
			InitializeComponent();
			g_Converter = new TMCanConvert.CanConverter();
		}

		private void Form1_Load(object sender, EventArgs e)
		{

		}

		private void button1_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.CompleteNumberWithCheck(szNumber);
			textBox2.Text = szNew;
		}

		private void button2_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeCountryCanonFormat(szNumber);
			textBox2.Text = szNew;
		}

		private void button3_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeCountryCanonFormatSimple(szNumber);
			textBox2.Text = szNew;
		}

		private void button4_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeCountryCanonFormatWB(szNumber);
			textBox2.Text = szNew;
		}

		private void button5_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeDialableNumber(szNumber);
			textBox2.Text = szNew;
		}

		private void button6_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeDialableNumber2(szNumber);
			textBox2.Text = szNew;
		}

		private void button7_Click(object sender, EventArgs e)
		{
			string szNumber = textBox1.Text;
			string szNew = g_Converter.MakeDialableNumberInternational(szNumber);
			textBox2.Text = szNew;
		}

		private void button9_Click(object sender, EventArgs e)
		{
			string szText = textBox1.Text;
			if ((szText.Length > 0) && (szText.Length < 2))
			{
				uint wLen = uint.Parse(szText);
				g_Converter.SetCanonMinDigits(wLen);
			}
		}

		private void button11_Click(object sender, EventArgs e)
		{
			Close();
		}
	}
}
