//****************************************************************************************
// Umwandlung von Rufnummern, z. B. in das kanonische Format
// Copyright  2001 - 2020 Tino Kasubke
//****************************************************************************************
#pragma once
//***************************************************************************************
// Include lib
#ifndef _USRDLL
#pragma comment(lib,"FCTICAN")
#endif
//****************************************************************************************
// Splitting der Lnder
VOID WINAPI MakeCountryCanonFormat(PTCHAR,PTCHAR _pszCity = NULL);
VOID WINAPI MakeCountryCanonFormatW(PWCHAR,PWCHAR _pwszCity = NULL);
VOID WINAPI MakeCountryCanonFormatWB(PTCHAR,PTCHAR _pszCity = NULL);
VOID WINAPI MakeCountryCanonFormatSimple(PTCHAR,PTCHAR _pszCity = NULL);
PTCHAR WINAPI MakeCountryCanonFormat2(PTCHAR);
PWCHAR WINAPI MakeCountryCanonFormat2W(PWCHAR);
VOID WINAPI MakeFixCanonFormat(DWORD,PTCHAR,PTCHAR);
VOID WINAPI MakeEmptyCanonFormat(PTCHAR,PTCHAR);
DWORD WINAPI GetNumberOfCodeArray(PDWORD);
VOID WINAPI QuicksortCodes(PDWORD,LONG,LONG);
VOID WINAPI MakeQuickSearchCanonFormat(PDWORD,LONG,PTCHAR,PTCHAR);
DWORD WINAPI GetCodeNumber(PDWORD,LONG,DWORD);
VOID WINAPI InitNumberTool();
VOID WINAPI SetCanonMinDigits(DWORD);
//****************************************************************************************
// Routinen fr die einzelnen Lnder
VOID MakeAustrianCanonFormat(PTCHAR);
VOID MakeGermanCanonFormat(PTCHAR);
VOID MakeSwissCanonFormat(PTCHAR);
VOID MakeChineseCanonFormat(PTCHAR);
VOID MakeFinnlandCanonFormat(PTCHAR);
VOID MakeGreeceCanonFormat(PTCHAR);
VOID MakeItalyCanonFormat(PTCHAR);
VOID MakeCroatianCanonFormat(PTCHAR);
VOID MakeSlovakianCanonFormat(PTCHAR);
VOID MakeHungarianCanonFormat(PTCHAR);
VOID MakeDutchCanonFormat(PTCHAR);
VOID MakePortugieseCanonFormat(PTCHAR);
VOID MakeThaiCanonFormat(PTCHAR);
VOID MakeArgentiniaCanonFormat(PTCHAR);
VOID MakeMalaysiaCanonFormat(PTCHAR);
VOID MakeIndonesiaCanonFormat(PTCHAR);
VOID MakePhilippinesCanonFormat(PTCHAR);
VOID MakeKoreaCanonFormat(PTCHAR);
VOID MakeVietnamCanonFormat(PTCHAR);
VOID MakeMyanmarCanonFormat(PTCHAR);
VOID MakeSriLankaCanonFormat(PTCHAR);
VOID MakeJapaneseCanonFormat(PTCHAR);
VOID MakeEgyptCanonFormat(PTCHAR);
VOID MakeNigerianCanonFormat(PTCHAR);
VOID MakeRomaniaCanonFormat(PTCHAR);
VOID MakeSwedenCanonFormat(PTCHAR);
VOID MakePolandCanonFormat(PTCHAR);
VOID MakeIrelandCanonFormat(PTCHAR);
VOID MakeCyprusCanonFormat(PTCHAR);
VOID MakeLithuaniaCanonFormat(PTCHAR);
VOID MakeLatviaCanonFormat(PTCHAR);
VOID MakeEstoniaCanonFormat(PTCHAR);
VOID MakeMoldovaCanonFormat(PTCHAR);
VOID MakeSerbiaCanonFormat(PTCHAR);
VOID MakeMacedoniaCanonFormat(PTCHAR);
VOID MakeCzechCanonFormat(PTCHAR);
VOID MakePeruanCanonFormat(PTCHAR);
VOID MakeChileCanonFormat(PTCHAR);
VOID MakeExAustraliaCanonFormat(PTCHAR);
VOID MakeTaiwanCanonFormat(PTCHAR);
VOID MakeLebanonCanonFormat(PTCHAR);
VOID MakeJordanCanonFormat(PTCHAR);
VOID MakeIrakCanonFormat(PTCHAR);
VOID MakeEmiratesCanonFormat(PTCHAR);
VOID MakeIsraelCanonFormat(PTCHAR);
VOID MakeNepalCanonFormat(PTCHAR);
VOID MakeTansaniaCanonFormat(PTCHAR);
VOID MakeMozambiqueCanonFormat(PTCHAR);
VOID MakeZambiaCanonFormat(PTCHAR);
VOID MakeMongoliaCanonFormat(PTCHAR);
VOID MakeTurkmenistanCanonFormat(PTCHAR);
VOID MakeAzerbaijanCanonFormat(PTCHAR);
VOID MakeGeorgiaCanonFormat(PTCHAR);
VOID MakeKyrgyzCanonFormat(PTCHAR);

// Andere Formatierroutinen fr Nummern
PTCHAR WINAPI MakeDialableNumber(PTCHAR);
PTCHAR WINAPI MakeDialableNumber2(PTCHAR);
PTCHAR WINAPI MakeDialableNumberInternational(PTCHAR);
PTCHAR WINAPI RemoveOwnCitiCode(PTCHAR,PTCHAR);
PTCHAR WINAPI CompleteNumberWithCheck(PTCHAR,PTCHAR);
//****************************************************************************************
