Public Class Form1
   Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      'Initialize the interface
      Call AxFCTIDataCtrl1.InitCOM()
      Label18.Text = AxFCTIDataCtrl1.LicenseCount()
   End Sub

   Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
      'Convert a number into the canonical format
      Dim szNumber As String
      szNumber = ""
      Call AxFCTIDataCtrl1.ConvertToCanonical(TextBox1.Text, szNumber)
      TextBox2.Text = szNumber
   End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Make ca call
        Call AxFCTIDataCtrl1.MakeCall(TextBox3.Text, TextBox4.Text)
    End Sub

   Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
      'Answer an incoming call
      Call AxFCTIDataCtrl1.Answer(TextBox3.Text)
   End Sub

   Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
      'Drop a call
      Call AxFCTIDataCtrl1.Drop(TextBox3.Text)
   End Sub

   Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
      'Set display text of a phone device (if supported)
      Call AxFCTIDataCtrl1.SetPhoneDisplay(TextBox5.Text, TextBox6.Text)
   End Sub

   Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
      'Send identity data to the client
      Dim lCall As Integer
      lCall = TextBox8.Text
      Call AxFCTIDataCtrl1.SendIdentity(lCall, TextBox7.Text, TextBox9.Text)
   End Sub

   Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
      'Send user defined data to the client
      Dim lCommand As Integer
      lCommand = TextBox11.Text
      Call AxFCTIDataCtrl1.SendUserData(lCommand, TextBox10.Text, TextBox12.Text)
   End Sub

   Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
      'Clear event list
      Call ListBox1.Items.Clear()
   End Sub

   Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
      'Close form
      Close()
   End Sub

	Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
		'Deflect a call
		Call AxFCTIDataCtrl1.Redirect(TextBox3.Text, TextBox4.Text)
	End Sub

   Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
      'Alternate
      Call AxFCTIDataCtrl1.Toggle(TextBox3.Text)
   End Sub

   Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
      'Transfer
      Call AxFCTIDataCtrl1.Transfer(TextBox3.Text)
   End Sub

   Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        'Conference
      Call AxFCTIDataCtrl1.Conference(TextBox3.Text)
   End Sub

   Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
      'Pickup a call
      Call AxFCTIDataCtrl1.Pickup(TextBox3.Text, TextBox4.Text)
   End Sub

	Private Sub AxFCTIDataCtrl1_OnCallNumber(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnCallNumberEvent) Handles AxFCTIDataCtrl1.OnCallNumber
		'Delivers the partner Number
		Dim szCallID As String
		szCallID = e.lCallId
		ListBox1.Items.Add("CTI_CALLNUMBER")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Call: " + szCallID)
		ListBox1.Items.Add("   Number: " + e.bstrNumber)
	End Sub

	Private Sub AxFCTIDataCtrl1_OnCallState(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnCallStateEvent) Handles AxFCTIDataCtrl1.OnCallState
		'Delevers the call status
		Dim szCallID As String
		szCallID = e.lCallId
		Dim szState As String
		szState = e.lState
		ListBox1.Items.Add("CTI_CALLSTATE")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Call: " + szCallID)
		ListBox1.Items.Add("   State: " + szState)
	End Sub

	Private Sub AxFCTIDataCtrl1_OnGetIdentity(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnGetIdentityEvent) Handles AxFCTIDataCtrl1.OnGetIdentity
		'Delivers info for identity 
		Dim szCallID As String
		szCallID = e.lCallId
		ListBox1.Items.Add("CTI_GETIDENTITY")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Call: " + szCallID)
		ListBox1.Items.Add("   Number: " + e.bstrNumber)
	End Sub

	Private Sub AxFCTIDataCtrl1_OnNewCall(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnNewCallEvent) Handles AxFCTIDataCtrl1.OnNewCall
		'Delivers informationen about a new call
		Dim szCallID As String
		szCallID = e.lCallId
		Dim szInbound As String
		szInbound = "No"
		If e.bInbound = True Then
			szInbound = "Yes"
		End If
		Dim szStartTime As String
		szStartTime = ""
		AxFCTIDataCtrl1.GetDateTime(e.lStart, szStartTime)
		ListBox1.Items.Add("CTI_NEWCALL")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Call: " + szCallID)
		ListBox1.Items.Add("   Inbound: " + szInbound)
		ListBox1.Items.Add("   Time: " + szStartTime)
		ListBox1.Items.Add("   Partner: " + e.bstrNumber)
	End Sub

	Private Sub AxFCTIDataCtrl1_OnProtocolData(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnProtocolDataEvent) Handles AxFCTIDataCtrl1.OnProtocolData
		'Delivers protocol data
		Dim szConnected As String
		szConnected = "No"
		If e.bSuccess = True Then
			szConnected = "Yes"
		End If
		Dim szInbound As String
		szInbound = "No"
		If e.bInbound = True Then
			szInbound = "Yes"
		End If
		Dim szStartTime As String
		Dim szEndTime As String
		szStartTime = ""
		szEndTime = ""
		AxFCTIDataCtrl1.GetFormatDateTime(e.lStart, "%H:%M:%S", szStartTime)
		AxFCTIDataCtrl1.GetFormatDateTime(e.lEnd, "%H:%M:%S", szEndTime)
		ListBox1.Items.Add("CTI_PROTOCOLDATA")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Partner: " + e.bstrNumber)
		ListBox1.Items.Add("   Address: " + e.bstrAddress)
		ListBox1.Items.Add("   Connected: " + szConnected)
		ListBox1.Items.Add("   Inbound: " + szInbound)
		ListBox1.Items.Add("   StartTime: " + szStartTime)
		ListBox1.Items.Add("   EndTime: " + szEndTime)
	End Sub

	Private Sub AxFCTIDataCtrl1_OnUserToDataBase(ByVal sender As Object, ByVal e As AxFCTIDATALib._IDataCtrlEvents_OnUserToDataBaseEvent) Handles AxFCTIDataCtrl1.OnUserToDataBase
		'User informations are sent to th database interface
		Dim szCommand As String
		szCommand = e.lCommand
		ListBox1.Items.Add("CTI_USERTODATABASE")
		ListBox1.Items.Add("   Internal: " + e.bstrUser)
		ListBox1.Items.Add("   Command: " + szCommand)
		ListBox1.Items.Add("   Text:" + e.bstrMessage)
	End Sub

    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click
        'Get forwarding info
        Dim szTarget As String
        Dim szSet As String
        Dim bSet As Boolean
        Dim szStatus As String
        szTarget = ""
        szSet = "off"
        bSet = False
        AxFCTIDataCtrl1.GetForwardingState(TextBox13.Text, szTarget, bSet)
        If bSet = True Then
            szSet = "on"
        End If
        szStatus = "Target: " + szTarget + " Set: " + szSet
        TextBox14.Text = szStatus
    End Sub

    Private Sub AxFCTIDataCtrl1_OnForwardingState(sender As Object, e As AxFCTIDATALib._IDataCtrlEvents_OnForwardingStateEvent) Handles AxFCTIDataCtrl1.OnForwardingState
        'Get forwarding changes
        Dim szSet As String
        szSet = "off"
        If e.bSet = True Then
            szSet = "on"
        End If
        ListBox1.Items.Add("CTI_FORWARDINGSTATE")
        ListBox1.Items.Add("   Internal: " + e.bstrUser)
        ListBox1.Items.Add("   Set: " + szSet)
        ListBox1.Items.Add("   Target: " + e.bstrTarget)
    End Sub
End Class
