Public Class Form1

   Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
      'Change the interface network settings
      AxFCTIClntCtrl1.NNetworkConfigDialog()
   End Sub

	Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
		'Make a call
		AxFCTIClntCtrl1.TMakeCall(TextBox1.Text)
	End Sub

   Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
      'Drop the call
      AxFCTIClntCtrl1.TCallDrop(0)
   End Sub

   Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
      'Answer an incoming call
      AxFCTIClntCtrl1.TCallAnswer(0)
	End Sub

   Private Sub AxFCTIClntCtrl1_OnForwardingState(ByVal sender As System.Object, ByVal e As AxFCTICLNTLib._IFCTIClntCtrlEvents_OnForwardingStateEvent) Handles AxFCTIClntCtrl1.OnForwardingState
      'Get the Forwarding state
      TextBox2.Text = e.bstrNumber
      CheckBox1.Checked = e.bSet
   End Sub

   Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
      'Set forward
      AxFCTIClntCtrl1.TSetForwarding(CheckBox1.Checked, TextBox2.Text)
   End Sub

   Private Sub AxFCTIClntCtrl1_OnCallNumber(ByVal sender As System.Object, ByVal e As AxFCTICLNTLib._IFCTIClntCtrlEvents_OnCallNumberEvent) Handles AxFCTIClntCtrl1.OnCallNumber
		'Number of caller will be delivered
		Label4.Text = e.bstrNumber
      If Label4.Text = "" Then
         Label4.Text = "Unknown"
      End If
   End Sub

   Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
      'Pickup a call
      AxFCTIClntCtrl1.TPickup(TextBox3.Text)
   End Sub

   Private Sub AxFCTIClntCtrl1_OnProtocolData(ByVal sender As System.Object, ByVal e As AxFCTICLNTLib._IFCTIClntCtrlEvents_OnProtocolDataEvent) Handles AxFCTIClntCtrl1.OnProtocolData
      'Protocal data will be send
      Dim TextLine As String
      Dim DatumText As String
      Dim InboundText As String
      Dim Duration As Long
      DatumText = ""
      InboundText = "Outbound"
      If e.bInbound = True Then
         InboundText = "Inbound"
      End If
      Duration = e.lEnd - e.lStart
      AxFCTIClntCtrl1.EGetFormatDateTime(e.lStart, "%Y-%B-%d %H:%M:%S", DatumText)
      TextLine = DatumText + " Own:" + e.bstrOwn + " Other:" + e.bstrOther + " Duration:" + Duration.ToString() + " " + InboundText
      ListBox1.Items.Add(TextLine)
   End Sub

   Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
      'Close the program
      Close()
   End Sub

   Private Sub AxFCTIClntCtrl1_OnGroupMember(ByVal sender As System.Object, ByVal e As AxFCTICLNTLib._IFCTIClntCtrlEvents_OnGroupMemberEvent) Handles AxFCTIClntCtrl1.OnGroupMember
      'Delivers the group members. Use it for the group buttons.
      If Member1.Text = "" Then
         If e.bstrName <> "" Then
            Member1.Text = e.bstrName
         Else
            Member1.Text = e.bstrNumber
         End If
         Member1.Enabled = True
         Member1.Tag = e.bstrNumber
      ElseIf Member2.Text = "" Then
         If e.bstrName <> "" Then
            Member2.Text = e.bstrName
         Else
            Member2.Text = e.bstrNumber
         End If
         Member2.Enabled = True
         Member2.Tag = e.bstrNumber
      ElseIf Member3.Text = "" Then
         If e.bstrName <> "" Then
            Member3.Text = e.bstrName
         Else
            Member3.Text = e.bstrNumber
         End If
         Member3.Enabled = True
         Member3.Tag = e.bstrNumber
      ElseIf Member4.Text = "" Then
         If e.bstrName <> "" Then
            Member4.Text = e.bstrName
         Else
            Member4.Text = e.bstrNumber
         End If
         Member4.Enabled = True
         Member4.Tag = e.bstrNumber
      ElseIf Member5.Text = "" Then
         If e.bstrName <> "" Then
            Member5.Text = e.bstrName
         Else
            Member5.Text = e.bstrNumber
         End If
         Member5.Enabled = True
         Member5.Tag = e.bstrNumber
      ElseIf Member6.Text = "" Then
         If e.bstrName <> "" Then
            Member6.Text = e.bstrName
         Else
            Member6.Text = e.bstrNumber
         End If
         Member6.Enabled = True
         Member6.Tag = e.bstrNumber
      ElseIf Member7.Text = "" Then
         If e.bstrName <> "" Then
            Member7.Text = e.bstrName
         Else
            Member7.Text = e.bstrNumber
         End If
         Member7.Enabled = True
         Member7.Tag = e.bstrNumber
      ElseIf Member8.Text = "" Then
         If e.bstrName <> "" Then
            Member8.Text = e.bstrName
         Else
            Member8.Text = e.bstrNumber
         End If
         Member8.Enabled = True
         Member8.Tag = e.bstrNumber
      ElseIf Member9.Text = "" Then
         If e.bstrName <> "" Then
            Member9.Text = e.bstrName
         Else
            Member9.Text = e.bstrNumber
         End If
         Member9.Enabled = True
         Member9.Tag = e.bstrNumber
      End If
   End Sub

   Private Sub AxFCTIClntCtrl1_OnSendUserState(ByVal sender As System.Object, ByVal e As AxFCTICLNTLib._IFCTIClntCtrlEvents_OnSendUserStateEvent) Handles AxFCTIClntCtrl1.OnSendUserState
      'Send the state of the group member
      If e.bstrNumber = Member1.Tag Then
         If e.bOfferings = True Then
            Member1.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member1.BackColor = Color.Red
         Else
            Member1.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member1.ForeColor = Color.DarkOrange
         Else
            Member1.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member2.Tag Then
         If e.bOfferings = True Then
            Member2.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member2.BackColor = Color.Red
         Else
            Member2.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member2.ForeColor = Color.DarkOrange
         Else
            Member2.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member3.Tag Then
         If e.bOfferings = True Then
            Member3.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member3.BackColor = Color.Red
         Else
            Member3.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member3.ForeColor = Color.DarkOrange
         Else
            Member3.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member4.Tag Then
         If e.bOfferings = True Then
            Member4.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member4.BackColor = Color.Red
         Else
            Member4.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member4.ForeColor = Color.DarkOrange
         Else
            Member4.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member5.Tag Then
         If e.bOfferings = True Then
            Member5.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member5.BackColor = Color.Red
         Else
            Member5.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member5.ForeColor = Color.DarkOrange
         Else
            Member5.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member6.Tag Then
         If e.bOfferings = True Then
            Member6.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member6.BackColor = Color.Red
         Else
            Member6.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member6.ForeColor = Color.DarkOrange
         Else
            Member6.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member7.Tag Then
         If e.bOfferings = True Then
            Member7.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member7.BackColor = Color.Red
         Else
            Member7.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member7.ForeColor = Color.DarkOrange
         Else
            Member7.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member8.Tag Then
         If e.bOfferings = True Then
            Member8.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member8.BackColor = Color.Red
         Else
            Member8.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member8.ForeColor = Color.DarkOrange
         Else
            Member8.ForeColor = Color.Black
         End If
      ElseIf e.bstrNumber = Member9.Tag Then
         If e.bOfferings = True Then
            Member9.BackColor = Color.Magenta
         ElseIf e.bActiveCall = True Then
            Member9.BackColor = Color.Red
         Else
            Member9.BackColor = Nothing
         End If
         If e.bLogin = True Then
            Member9.ForeColor = Color.DarkOrange
         Else
            Member9.ForeColor = Color.Black
         End If
      End If
   End Sub

   Private Sub Member1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member1.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member1.Tag.ToString())
   End Sub

   Private Sub Member2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member2.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member2.Tag.ToString())
   End Sub

   Private Sub Member3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member3.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member3.Tag.ToString())
   End Sub

   Private Sub Member4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member4.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member4.Tag.ToString())
   End Sub

   Private Sub Member5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member5.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member5.Tag.ToString())
   End Sub

   Private Sub Member6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member6.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member6.Tag.ToString())
   End Sub

   Private Sub Member7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member7.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member7.Tag.ToString())
   End Sub

   Private Sub Member8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member8.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member8.Tag.ToString())
   End Sub

   Private Sub Member9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Member9.Click
      'Dial a Number
      AxFCTIClntCtrl1.TMakeCall(Member9.Tag.ToString())
   End Sub

   Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
      'Hold the first call
      AxFCTIClntCtrl1.TCallHold(0)
   End Sub

   Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
      'Unhold = Retrieve
      AxFCTIClntCtrl1.TCallUnHold(0)
   End Sub

   Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
      'Transfer
      AxFCTIClntCtrl1.TCallTransfer(0, 0)
   End Sub

   Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
      'Redirect existing call
      AxFCTIClntCtrl1.TCallRedirect(0, TextBox5.Text)
   End Sub

	Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		'Initialize the interface
		AxFCTIClntCtrl1.OOptions = 414
		AxFCTIClntCtrl1.OUserCallInfo = True
		AxFCTIClntCtrl1.OShowIcon = True
		AxFCTIClntCtrl1.OShowMenu = True
		AxFCTIClntCtrl1.OConnectionIconOptions(0, 0, 0, "CTI-Test")
		AxFCTIClntCtrl1.NStartClient()
	End Sub
End Class
